package partner;

import java.io.*;
import java.net.*;
import org.w3c.dom.*;
import commons.XTrustProvider;
import javax.net.ssl.HttpsURLConnection;
import javax.xml.parsers.*;

/**
 * GetMemberIDForMAU
 * [ ޼ ̿ 㰡 API ̿ڿ ؼ Ű ؼϿ MemberID Ͽ ݴϴ.]
 * https://api.auction.co.kr/Archesystem/mainservice.asmx?op=GetMemberIDForMAU
 * 
 *  ǽÿ Request SOAP Response SOAP ֽø ˴ϴ.
 *  API  Ŀ´Ƽ : http://api.auction.co.kr/developer
 * 
 * 1. α ʿ 񽺴 RequestApplicationTicket 񽺸 ȣؼ  Ƽ ų ٸ 񽺸 ȣϰ   Ű  ԷѴ.
 * 2. GetMemberIDForMAU 񽺸 ȣѴ.
 * 3. GetMemberIDForMAU 񽺸 ȣϰ   Ƽ  ٸ 񽺸 ȣ ,  Էϰ ȣѴ.  
 */
public class GetMemberIDForMAU {
	
	public static void main(String[] args) {
		XTrustProvider.install();
		
        //String serverUrl = "https://api.auction.co.kr/Archesystem/mainservice.asmx";	// 󼭹
        String serverUrl = "https://apitest.auction.co.kr/Archesystem/mainservice.asmx";	// ׽Ʈ
        String soapAction = "http://www.auction.co.kr/ServiceInterfaces/Main/GetMemberIDForMAU";
        
        try
        {
            //Create a HttpsURLConnection with the correct server
            URL server = new URL(serverUrl);
            HttpURLConnection connection = (HttpURLConnection) (server.openConnection());
            //HttpsURLConnection connection = (HttpsURLConnection) (server.openConnection());	// SSL 
            
            //Add the necessary headers to the connection
            addAuctionHTTPHeaders(connection, soapAction);
            
	        /* SOAP Request ۼ */
	        StringBuffer request_xml = new StringBuffer();
	        request_xml.append ("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
	        request_xml.append ("<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">");
	        request_xml.append ("<soap:Header>");
	        request_xml.append ("<EncryptedTicket xmlns=\"http://www.auction.co.kr/Security\">");
	        request_xml.append ("<Value>string</Value>");
	        request_xml.append ("</EncryptedTicket>");
	        request_xml.append ("</soap:Header>");
	        request_xml.append ("<soap:Body>");
	        request_xml.append ("<GetMemberIDForMAU xmlns=\"http://www.auction.co.kr/ServiceInterfaces/Main\">");
	        request_xml.append ("<AuthenticationCookieString>string</AuthenticationCookieString>");
	        request_xml.append ("</GetMemberIDForMAU>");
	        request_xml.append ("</soap:Body>");
	        request_xml.append ("</soap:Envelope>");
	        
	        //Print SOAP Request
	        System.out.println("****REQUEST SOAP****");
	        System.out.println(request_xml.toString().replaceAll("><", ">\r\n<"));
	        
            //Get the output stream of the connection
            OutputStream out = connection.getOutputStream();
            out.write(request_xml.toString().getBytes("UTF-8"));
	        out.flush();
	        out.close();
	        
            //Send the request and return the resulting XML document
            Document xmlDoc = SendRequest(connection);
            //if null is returned then there was an error
            if(xmlDoc == null) return;
            
            /* Process Response */
            System.out.println("\r\n****PROCESS RESPONSE****");
            //  Ű ( 񽺸 ȣҶ,  Էؼ ȣѴ.)
            Element ticket = (Element) xmlDoc.getElementsByTagName("EncryptedTicket").item(0);
            if (ticket != null) {
            	System.out.println("Ticket: " + ticket.getElementsByTagName("Value").item(0).getChildNodes().item(0).getNodeValue());
            }
            Element element = (Element) xmlDoc.getElementsByTagName("Item").item(0);
            if (element != null) {
            	if (element.getAttributes().getNamedItem("ItemID") != null) {
            		System.out.println("ItemID: " + element.getAttributes().getNamedItem("ItemID").getNodeValue());
            	}
            	if (element.getAttributes().getNamedItem("Name") != null) {
            		System.out.println("Name: " + element.getAttributes().getNamedItem("Name").getNodeValue());
            	}
            }
            
        } catch(Exception e) {
        	e.printStackTrace();
        }
	}
    /**
     * Sends the request to the Server and returns the Document (XML)
     * that is returned as the response.
     */    
    private static Document SendRequest(HttpURLConnection connection) {
        try
        {
            //Get the Input stream for the response
            InputStream in = connection.getInputStream();
	        
	        //Get the XML file into a Document object
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuild = factory.newDocumentBuilder();
            //Get the stream into a Document object
	        Document response = docBuild.parse(in);
	        
	        //Print SOAP Response
            System.out.println("\r\n****RESPONSE SOAP****");
            System.out.println(response.getDocumentElement().toString().replaceAll("><", ">\r\n<"));
            
            //close the input stream and connection
            in.close();
            
            //return the response XML Document
            return response;
        } catch(IOException e) {
            System.out.println("SendRequest IO Error: " + e.toString());
            //e.printStackTrace();
            
            try {
	            InputStream es = connection.getErrorStream();
	            //Get the XML file into a Document object
	            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	            DocumentBuilder docBuild = factory.newDocumentBuilder();
	            //Get the stream into a Document object
		        Document response = docBuild.parse(es);
		        System.out.println(response.getDocumentElement());
		        
		        es.close();
            } catch (Exception e2){}

            return null;
        } catch(Exception e) {
            System.out.println("Error Sending Request: " + e.toString());
            e.printStackTrace();
            
            return null;
        }
        finally {
        	if (connection != null) connection.disconnect();
        }
    }
    /**
     * Adds the necessary headers to the HttpsURLConnection passed in
     * order for the call to be successful
     */
    private static void addAuctionHTTPHeaders(HttpURLConnection connection, String soapAction) throws ProtocolException
    {
    	connection.setRequestMethod("POST");
        connection.setRequestProperty("SOAPAction", soapAction);
        connection.setRequestProperty("Host", "api.auction.co.kr");
        connection.setRequestProperty("Content-Type", "text/xml; charset=utf-8");
    	
    	connection.setDoInput(true);
    	connection.setDoOutput(true);
    }
}
