package partner;

import java.io.*;
import java.net.*;
import org.w3c.dom.*;
import commons.XTrustProvider;
import javax.net.ssl.HttpsURLConnection;
import javax.xml.parsers.*;

/**
 * RequestApplicationTicket
 * [Ķ͸ ϰ ø̼ Ƽ ûմϴ.]
 * https://api.auction.co.kr/Archesystem/Securityservice.asmx?op=RequestApplicationTicket
 * 
 *  ǽÿ Request SOAP Response SOAP ֽø ˴ϴ.
 *  API  Ŀ´Ƽ : http://api.auction.co.kr/developer
 * 
 * 1.  ȣÿ ʿ  Ƽ ߱ ޴´.
 */
public class RequestApplicationTicket {
	
	public static void main(String[] args) {
		XTrustProvider.install();
		
        //String serverUrl = "https://api.auction.co.kr/Archesystem/Securityservice.asmx";	// 󼭹
        String serverUrl = "https://apitest.auction.co.kr/Archesystem/Securityservice.asmx";	// ׽Ʈ
        String soapAction = "http://www.auction.co.kr/ServiceInterfaces/Security/RequestApplicationTicket";
        
        try
        {
            //Create a HttpsURLConnection with the correct server
            URL server = new URL(serverUrl);
            HttpURLConnection connection = (HttpURLConnection) (server.openConnection());
            //HttpsURLConnection connection = (HttpsURLConnection) (server.openConnection());	// SSL 

            //Add the necessary headers to the connection
            addAuctionHTTPHeaders(connection, soapAction);

	        /* SOAP Request ۼ */
	        StringBuffer request_xml = new StringBuffer();
	        request_xml.append ("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
	        request_xml.append ("<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">");
	        request_xml.append ("<soap:Body>");
	        request_xml.append ("<RequestApplicationTicket xmlns=\"http://www.auction.co.kr/ServiceInterfaces/Security\">");
	        request_xml.append ("<req DevID=\"\" AppID=\"\" AppPassword=\"\" />");
	        request_xml.append ("</RequestApplicationTicket>");
	        request_xml.append ("</soap:Body>");
	        request_xml.append ("</soap:Envelope>");
	        
	        //Print SOAP Request
	        System.out.println("****REQUEST SOAP****");
	        System.out.println(request_xml.toString().replaceAll("><", ">\r\n<"));

            //Get the output stream of the connection
            OutputStream out = connection.getOutputStream();
            out.write(request_xml.toString().getBytes("UTF-8"));
	        out.flush();
	        out.close();

            //Send the request and return the resulting XML document
            Document xmlDoc = SendRequest(connection);
            //if null is returned then there was an error
            if(xmlDoc == null) return;
            
            /* Process Response */
            System.out.println("\r\n****PROCESS RESPONSE****");
            // Ƽ
            Element element = (Element) xmlDoc.getElementsByTagName("RequestApplicationTicketResult").item(0);
            if (element != null) {
            	System.out.println("RequestApplicationTicketResult: " + element.getChildNodes().item(0).getNodeValue());
            }

        } catch(Exception e) {
        	e.printStackTrace();
        }
	}
    /**
     * Sends the request to the Server and returns the Document (XML)
     * that is returned as the response.
     */    
    private static Document SendRequest(HttpURLConnection connection) {
        try
        {
            //Get the Input stream for the response
            InputStream in = connection.getInputStream();
	        
	        //Get the XML file into a Document object
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuild = factory.newDocumentBuilder();
            //Get the stream into a Document object
	        Document response = docBuild.parse(in);
	        
	        //Print SOAP Response
            System.out.println("\r\n****RESPONSE SOAP****");
            System.out.println(response.getDocumentElement().toString().replaceAll("><", ">\r\n<"));
            
            //close the input stream and connection
            in.close();
            
            //return the response XML Document
            return response;
        } catch(IOException e) {
            System.out.println("SendRequest IO Error: " + e.toString());
            //e.printStackTrace();
            
            try {
	            InputStream es = connection.getErrorStream();
	            //Get the XML file into a Document object
	            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	            DocumentBuilder docBuild = factory.newDocumentBuilder();
	            //Get the stream into a Document object
		        Document response = docBuild.parse(es);
		        System.out.println(response.getDocumentElement());
		        
		        es.close();
            } catch (Exception e2){}

            return null;
        } catch(Exception e) {
            System.out.println("Error Sending Request: " + e.toString());
            e.printStackTrace();
            
            return null;
        }
        finally {
        	if (connection != null) connection.disconnect();
        }
    }
    /**
     * Adds the necessary headers to the HttpsURLConnection passed in
     * order for the call to be successful
     */
    private static void addAuctionHTTPHeaders(HttpURLConnection connection, String soapAction) throws ProtocolException
    {
    	connection.setRequestMethod("POST");
        connection.setRequestProperty("SOAPAction", soapAction);
        connection.setRequestProperty("Host", "api.auction.co.kr");
        connection.setRequestProperty("Content-Type", "text/xml; charset=utf-8");
    	
    	connection.setDoInput(true);
    	connection.setDoOutput(true);
    }
}
