package service1;

import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import commons.WSRequestHandler;
import commons.XTrustProvider;

/**
 * GetSearchResults
 * [˻]
 * https://api.auction.co.kr/APIv1/AuctionService.asmx?op=GetSearchResults
 *
 *  ǽÿ Request SOAP Response SOAP ֽø ˴ϴ.
 *  API  Ŀ´Ƽ : http://api.auction.co.kr/developer
 *
 * 1. α ʿ 񽺴 RequestApplicationTicket 񽺸 ȣؼ  Ƽ ų ٸ 񽺸 ȣϰ   Ű  ԷѴ.
 * 2. ViewItem 񽺸 ȣѴ.
 * 3. ViewItem 񽺸 ȣϰ   Ƽ  ٸ 񽺸 ȣ ,  Էϰ ȣѴ.
 */
public class GetSearchResults {

	public static void main(String[] args) {
		String q = "ƺ";
		Map item = getItemByRandom(q);
		System.out.println(item.get("name"));
		System.out.println(item.get("itemId"));
		System.out.println(item.get("image"));
		System.out.println(item.get("buyItNowPrice"));
	}
	
	public static Map getItemByRandom(String q) {
		List list = search(q);
		int size = list.size();
		Random random = new Random();
		int index = random.nextInt(size);
		return (Map) list.get(index);
	}

	public static List search(String q) {
		XTrustProvider.install();

        //String serverUrl = "http://api.auction.co.kr/APIv1/Auctionservice.asmx";	// 󼭹
        String serverUrl = "http://apitest.auction.co.kr/APIv1/Auctionservice.asmx";	// ׽Ʈ
        String soapAction = "http://www.auction.co.kr/APIv1/AuctionService/GetSearchResults";

        List list = new ArrayList();
        try {
            //Create a HttpsURLConnection with the correct server
            URL server = new URL(serverUrl);
            HttpURLConnection connection = (HttpURLConnection) (server.openConnection());
            //HttpsURLConnection connection = (HttpsURLConnection) (server.openConnection());	// SSL 

            //Add the necessary headers to the connection
            WSRequestHandler.addAuctionHTTPHeaders(connection, soapAction);

            String ticket = RequestApplicationTicket.getTicket();
	        /* SOAP Request ۼ */
	        StringBuffer request_xml = new StringBuffer();
	        request_xml.append ("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
	        request_xml.append ("<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">");
	        request_xml.append ("<soap:Header>");
	        request_xml.append ("<EncryptedTicket xmlns=\"http://www.auction.co.kr/Security\">");
	        // RequestApplicationTicket  Ƽ ְų, ٸ 񽺸 ȣϰ  Ƽ ԷѴ.
			request_xml.append ("<Value>"+ticket+"</Value>");
	        request_xml.append ("</EncryptedTicket>");
	        request_xml.append ("</soap:Header>");
	        request_xml.append ("<soap:Body>");
	        request_xml.append ("<GetSearchResults xmlns=\"http://www.auction.co.kr/APIv1/AuctionService\">");
	        request_xml.append ("<req>");
	        request_xml.append ("<DetailLevel xmlns=\"http://schema.auction.co.kr/Arche.APISvc.xsd\">ReturnAll</DetailLevel>");
			request_xml.append ("<Query xmlns=\"http://schema.auction.co.kr/Arche.APISvc.xsd\">"+q +"</Query>");
	        request_xml.append ("<PriceRangeFilter MinPrice=\"1000\" MaxPrice=\"500000\" MinBinPrice=\"1000\" MaxBinPrice=\"500000\" xmlns=\"http://schema.auction.co.kr/Arche.APISvc.xsd\" />");
	        request_xml.append ("<ItemType xmlns=\"http://schema.auction.co.kr/Arche.APISvc.xsd\">AllItemTypes</ItemType>");
	        request_xml.append ("<Order xmlns=\"http://schema.auction.co.kr/Arche.APISvc.xsd\">HighestPriceFirst</Order>");
	        request_xml.append ("<Pagination PageIndex=\"1\" PageSize=\"50\" xmlns=\"http://schema.auction.co.kr/Arche.APISvc.xsd\" />");
	        request_xml.append ("<TotalOnly xmlns=\"http://schema.auction.co.kr/Arche.APISvc.xsd\">false</TotalOnly>");
	        request_xml.append ("<LocationTo xmlns=\"http:///schema.auction.co.kr/Arche.APISvc.xsd\">Country</LocationTo>");
	        request_xml.append ("<Used xmlns=\"http://schema.auction.co.kr/Arche.APISvc.xsd\">false</Used>");
	        request_xml.append ("</req>");
	        request_xml.append ("</GetSearchResults>");
	        request_xml.append ("</soap:Body>");
	        request_xml.append ("</soap:Envelope>");

	        //Print SOAP Request
	        System.out.println("****REQUEST SOAP****");
	        System.out.println(request_xml.toString().replaceAll("><", ">\r\n<"));

            //Get the output stream of the connection
            OutputStream out = connection.getOutputStream();
            out.write(request_xml.toString().getBytes("UTF-8"));
	        out.flush();
	        out.close();

            //Send the request and return the resulting XML document
            Document xmlDoc = WSRequestHandler.SendRequest(connection);

            //if null is returned then there was an error
            if(xmlDoc == null) return list;

            /* Process Response */
            System.out.println("\r\n****PROCESS RESPONSE****");
            //  Ű ( 񽺸 ȣҶ,  Էؼ ȣѴ.)
            Element eticket = (Element) xmlDoc.getElementsByTagName("EncryptedTicket").item(0);
            if (eticket != null) {
            	System.out.println("Ticket: " + eticket.getElementsByTagName("Value").item(0).getChildNodes().item(0).getNodeValue());
            }
            NodeList elementsByTagName = xmlDoc.getElementsByTagName("SearchResultItem");
            int length = elementsByTagName.getLength();
            
			for (int i = 0; i < length; i++) {
				Element element = (Element) elementsByTagName.item(i);
				Map basicInfo = getBasicInfo(element);
				list .add(basicInfo);
			}

        } catch(Exception e) {
        	e.printStackTrace();
        }
        return list;
	}

	/**
	 * @param element
	 */
	private static Map getBasicInfo(Element element) {
		Map map = new HashMap();
		if (element != null) {
			Node node = element.getAttributes().getNamedItem("ItemID");
			if (node != null) {
				map.put("itemId" , node.getNodeValue());
			}
			node = element.getAttributes().getNamedItem("Name");
			if (node != null) {
				map.put("name" , node.getNodeValue());
			}
			node = element.getElementsByTagName("PictureDetails").item(0)
				.getChildNodes().item(0);
			if (node != null) {
				map.put("image",node.getFirstChild().getNodeValue());
			}
			node = element.getAttributes().getNamedItem("BuyItNowPrice");
			if (node != null) {
				NumberFormat nf = NumberFormat.getInstance();
				try {
					long price = Long.parseLong(node.getNodeValue());
					map.put("buyItNowPrice" , nf.format(price)+"");
				} catch (Exception e) {
					map.put("buyItNowPrice" , "N/A");
				}
			}
		}
		return map;
	}
  
}
