package service1;

import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import commons.WSRequestHandler;
import commons.XTrustProvider;

/**
 * RequestApplicationTicket
 * [Ķ͸ ϰ ø̼ Ƽ ûմϴ]
 * https://api.auction.co.kr/APIv1/SecurityService.asmx?op=RequestApplicationTicket
 * 
 *  ǽÿ Request SOAP Response SOAP ֽø ˴ϴ.
 *  API  Ŀ´Ƽ : http://api.auction.co.kr/developer
 * 
 * 1.  ȣÿ ʿ  Ƽ ߱ ޴´.
 */
public class RequestApplicationTicket {
	
	public static void main(String[] args) {
		String ticket = getTicket();
        System.out.println("RequestApplicationTicketResult: " + ticket);
	}

	public static String getTicket() {
		XTrustProvider.install();
		
        //String serverUrl = "http://api.auction.co.kr/APIv1/Auctionservice.asmx";	// 󼭹
        String serverUrl = "https://apitest.auction.co.kr/APIv1/Securityservice.asmx";	// ׽Ʈ
        String soapAction = "http://www.auction.co.kr/ServiceInterfaces/RequestApplicationTicket";
        String ticket = null;
        try
        {
            //Create a HttpsURLConnection with the correct server
            URL server = new URL(serverUrl);
            HttpURLConnection connection = (HttpURLConnection) (server.openConnection());
            //HttpsURLConnection connection = (HttpsURLConnection) (server.openConnection());	// SSL 

            //Add the necessary headers to the connection
            WSRequestHandler.addAuctionHTTPHeaders(connection, soapAction);

	        /* SOAP Request ۼ */
	        StringBuffer request_xml = new StringBuffer();
	        request_xml.append ("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
	        request_xml.append ("<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">");
	        request_xml.append ("<soap:Body>");
	        request_xml.append ("<RequestApplicationTicket xmlns=\"http://www.auction.co.kr/ServiceInterfaces\">");
	        request_xml.append ("<req DevID=\"kenu\" AppID=\"okjsp\" AppPassword=\"\" />");
	        request_xml.append ("</RequestApplicationTicket>");
	        request_xml.append ("</soap:Body>");
	        request_xml.append ("</soap:Envelope>");
	        
	        //Print SOAP Request
	        System.out.println("****REQUEST SOAP****");
	        System.out.println(request_xml.toString().replaceAll("><", ">\r\n<"));

            //Get the output stream of the connection
            OutputStream out = connection.getOutputStream();
            out.write(request_xml.toString().getBytes("UTF-8"));
	        out.flush();
	        out.close();

            //Send the request and return the resulting XML document
            Document xmlDoc = WSRequestHandler.SendRequest(connection);
            //if null is returned then there was an error
            if(xmlDoc != null) {
            	/* Process Response */
            	// Ƽ
            	Element element = (Element) xmlDoc.getElementsByTagName("RequestApplicationTicketResult").item(0);
            	if (element != null) {
            		ticket = element.getChildNodes().item(0).getNodeValue();
            	}
            }
        } catch(Exception e) {
        	e.printStackTrace();
        }
		return ticket;
	}
}
