package service2;

import java.io.*;
import java.net.*;
import org.w3c.dom.*;
import commons.XTrustProvider;
import javax.net.ssl.HttpsURLConnection;
import javax.xml.parsers.*;

/**
 * AddItem
 * [ǰ ]
 * https://api.auction.co.kr/APIv1/AuctionService.asmx?op=AddItem
 * 
 *  ǽÿ Request SOAP Response SOAP ֽø ˴ϴ.
 *  API  Ŀ´Ƽ : http://api.auction.co.kr/developer
 * 
 * 1. α ʿ 񽺴 ǿ ϴ α    Ƽ ų, ٸ 񽺸 ȣ ϰ  Ű ޾ƿ´.
 * 2. AddItem 񽺸 ȣѴ.
 * 3. AddItem 񽺸 ȣϰ   Ƽ  ٸ 񽺸 ȣ ,  Էϰ ȣѴ. 
 */
public class AddItem {
	
	public static void main(String[] args) {
		XTrustProvider.install();
		
        //String serverUrl = "http://api.auction.co.kr/APIv1/Auctionservice.asmx";	// 󼭹
        String serverUrl = "http://apitest.auction.co.kr/APIv1/Auctionservice.asmx";	// ׽Ʈ
        String soapAction = "http://www.auction.co.kr/APIv1/AuctionService/AddItem";
        
        try
        {
            //Create a HttpsURLConnection with the correct server
            URL server = new URL(serverUrl);
            HttpURLConnection connection = (HttpURLConnection) (server.openConnection());
            //HttpsURLConnection connection = (HttpsURLConnection) (server.openConnection());	// SSL 

            //Add the necessary headers to the connection
            addAuctionHTTPHeaders(connection, soapAction);

	        /* SOAP Request ۼ */
	        StringBuffer request_xml = new StringBuffer();
			request_xml.append ("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
			request_xml.append ("<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">");
			request_xml.append ("<soap:Header>");
			request_xml.append ("<EncryptedTicket xmlns=\"http://www.auction.co.kr/Security\">");
			request_xml.append ("<Value></Value>");	// ǿ ϴ α   Ƽ ͼ Էϰų, ٸ 񽺸 ȣϰ   Ƽ ԷѴ.
			request_xml.append ("</EncryptedTicket>");
			request_xml.append ("</soap:Header>");
			request_xml.append ("<soap:Body>");
			request_xml.append ("<AddItem xmlns=\"http://www.auction.co.kr/APIv1/AuctionService\">");
			request_xml.append ("<req>");
			request_xml.append ("<Registry ItemName=\"ǰ\" CategoryID=\"13080500\" ImportedCountry=\"߱\" StartDateTime=\"2007-09-19 20:52\" EndTime=\"23:59\" Term=\"Day7\" PriceCompareMatch=\"false\" xmlns=\"http://schema.auction.co.kr/Arche.APISvc.xsd\">");
			request_xml.append ("<Item SellingType=\"FixedPriceItem\" AdMessage=\"0000\" BuyItNowPrice=\"1000\" Quantity=\"100\" BuyableQuantity=\"10\" ShippingRegions=\"Country\" OfferingAfterService=\"true\" ASInfo=\"\" TradeDescription=\"\" IsDiscountInFull=\"false\">");
			request_xml.append ("<ListingDetails Adult=\"false\"/>");
			request_xml.append ("<ReceiptType Invoice=\"true\"/>");
			request_xml.append ("<Origin type=\"Foreign\" Place=\"߱\"/>");
			request_xml.append ("<Brand BrandName=\"\"/>");
			request_xml.append ("<Shipping ShippingType=\"Door2Door\">");
			request_xml.append ("<PaymentType>Free</PaymentType>");
			request_xml.append ("<IsPrepayable>false</IsPrepayable>");
			request_xml.append ("<IsBundleShipping>true</IsBundleShipping>");
			request_xml.append ("<ConditionType>Amount</ConditionType>");
			request_xml.append ("</Shipping>");
			request_xml.append ("<InterestFee>None</InterestFee>");
			request_xml.append ("<Option OptionType=\"NotAllowed\"/>");
			request_xml.append ("</Item>");
			request_xml.append ("<Description Description=\"test\" isTop=\"true\" isHtml=\"true\"/>");
			request_xml.append ("</Registry>");
			request_xml.append ("</req>");
			request_xml.append ("</AddItem>");
			request_xml.append ("</soap:Body>");
			request_xml.append ("</soap:Envelope>");
	        
	        //Print SOAP Request
	        System.out.println("****REQUEST SOAP****");
	        System.out.println(request_xml.toString().replaceAll("><", ">\r\n<"));

            //Get the output stream of the connection
            OutputStream out = connection.getOutputStream();
            out.write(request_xml.toString().getBytes("UTF-8"));
	        out.flush();
	        out.close();

            //Send the request and return the resulting XML document
            Document xmlDoc = SendRequest(connection);
            //if null is returned then there was an error
            if(xmlDoc == null) return;
            
            /* Process Response */
            System.out.println("\r\n****PROCESS RESPONSE****");
            //  Ű ( 񽺸 ȣҶ,  Էؼ ȣѴ.)
            Element ticket = (Element) xmlDoc.getElementsByTagName("EncryptedTicket").item(0);
            if (ticket != null) {
            	System.out.println("Ticket: " + ticket.getElementsByTagName("Value").item(0).getChildNodes().item(0).getNodeValue());
            }
            Element element = (Element) xmlDoc.getElementsByTagName("AddItemResult").item(0);
            if (element != null) {
            	if (element.getAttributes().getNamedItem("ItemID") != null) {
            		System.out.println("ItemID: " + element.getAttributes().getNamedItem("ItemID").getNodeValue());
            	}
            	if (element.getAttributes().getNamedItem("Fee") != null) {
            		System.out.println("Fee: " + element.getAttributes().getNamedItem("Fee").getNodeValue());
            	}
            }

        } catch(Exception e) {
        	e.printStackTrace();
        }
	}
    /**
     * Sends the request to the Server and returns the Document (XML)
     * that is returned as the response.
     */    
    private static Document SendRequest(HttpURLConnection connection) {
        try
        {
            //Get the Input stream for the response
            InputStream in = connection.getInputStream();
	        
	        //Get the XML file into a Document object
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuild = factory.newDocumentBuilder();
            //Get the stream into a Document object
	        Document response = docBuild.parse(in);
	        
	        //Print SOAP Response
            System.out.println("\r\n****RESPONSE SOAP****");
            System.out.println(response.getDocumentElement().toString().replaceAll("><", ">\r\n<"));
            
            //close the input stream and connection
            in.close();
            
            //return the response XML Document
            return response;
        } catch(IOException e) {
            System.out.println("SendRequest IO Error: " + e.toString());
            //e.printStackTrace();
            
            try {
	            InputStream es = connection.getErrorStream();
	            //Get the XML file into a Document object
	            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	            DocumentBuilder docBuild = factory.newDocumentBuilder();
	            //Get the stream into a Document object
		        Document response = docBuild.parse(es);
		        System.out.println(response.getDocumentElement());
		        
		        es.close();
            } catch (Exception e2){}

            return null;
        } catch(Exception e) {
            System.out.println("Error Sending Request: " + e.toString());
            e.printStackTrace();
            
            return null;
        }
        finally {
        	if (connection != null) connection.disconnect();
        }
    }
    /**
     * Adds the necessary headers to the HttpsURLConnection passed in
     * order for the call to be successful
     */
    private static void addAuctionHTTPHeaders(HttpURLConnection connection, String soapAction) throws ProtocolException
    {
    	connection.setRequestMethod("POST");
        connection.setRequestProperty("SOAPAction", soapAction);
        connection.setRequestProperty("Host", "api.auction.co.kr");
        connection.setRequestProperty("Content-Type", "text/xml; charset=utf-8");
    	
    	connection.setDoInput(true);
    	connection.setDoOutput(true);
    }
}
